#!/usr/bin/python
import numpy as np
from operator import itemgetter
from sys import argv





inDir = argv[1]
expDir = argv[2]
kmerList = argv[3:]


finalPredictionsFile = expDir + "/finalPredictions"
pFiles = []
for kmer in kmerList:
    tmp = inDir+'/predictions_'+str(kmer)
    pFiles.append(tmp)



# #for test
# kmerList  = [53,55,57]
# inDir = '/media/student/study_working/project/project10/BHap/test_data/NC_009515.1_0.01_100_400_10.0a20.0a30.0a40.0_0.001/'
# expDir = '/media/student/study_working/project/project10/BHap/test_res/'
# finalPredictionsFile = expDir + "finalPredictions_test"
# #pFiles = glob.glob(expDir + "/predictions_*")
# pFiles = []
# for kmer in kmerList:
#     tmp = inDir+'/predictions_'+str(kmer)
#     pFiles.append(tmp)




#########################################################################################################3
#calcualte the reliability between two haplotype
def calculate_reliability(snp1,snp2):

    similar_com = 0
    for loc1 in snp1:
        if loc1 in snp2:
            similar_com += 1

    reliable = similar_com*1.0 / (len(snp1)+len(snp2))

    return reliable

##########################################################################################################
#read the all haplotype by all kmer
kmerCov = {}
for file in pFiles:
    try:
        kmer = file.split("_")[-1]
        f = open(file)
        lines = f.readlines()
        lines = [item.strip() for item in lines]
        lines = [item.split(":") for item in lines]

        kmerCov.update({kmer:{}})
        covPol = dict((float(item[0]), [p for p in item[1].split("*")]) for item in lines)
        for key,value in covPol.iteritems():
            kmerCov[kmer].update({key:value})
        f.close()
    except:
        print ' '.join([file,'does not exist'])

#cluster the haplotype
#sort the haplotype by number of haplotype, and put dataset with only one haplotype to the end of list
order = [(int(key),len(value)) for key,value in kmerCov.iteritems()]
order.sort(key=itemgetter(1,0))
order_endList = [item for ID,item in enumerate(order) if item[1]==1]
for i in range(len(order_endList)):
    order.pop(0)
for item in order_endList:
    order.append(item)


#cluster
avgCov_coverage = []
avgCov_SNPs = []
first = True
for item in order:
    kmer = str(item[0])
    numHaplotype = item[1]
    coverageSNPs = kmerCov[kmer]
    sortedCov = sorted([key for key in coverageSNPs.keys()])

    #first coverage
    if first == True:
        first = False
        for coverage in sortedCov:
            avgCov_coverage.append([coverage])
            avgCov_SNPs.append([coverageSNPs[coverage]])
    else:
        for coverage in sortedCov:
            #if there is only one haplotype(predicted in previous dataset) in coverage list from one dataset.
            if len(avgCov_coverage)==1:
                tmp_aveCoverage = np.mean(avgCov_coverage[0])

                #check similarity between this coverage with known cluster. The known cluster may have more than one SNPs set
                similarityList = []
                similarityListThreshold = []
                for SNPs in avgCov_SNPs[0]:
                    snp1 = set()
                    for one in SNPs:
                        snp1.add(one)
                    snp2 = set(coverageSNPs[coverage])
                    reliability = calculate_reliability(snp1, snp2)
                    similarityList.append(reliability)

                    lowerLength = min([len(snp1),len(snp2)])
                    similarityListThreshold.append(lowerLength*0.5/(len(snp1)+len(snp2)))

                tmp_avgThreshold = np.mean(similarityListThreshold)
                #whether this two cluster are similar:(1)coverage.(2)similarity score
                if coverage>=(tmp_aveCoverage-0.5*tmp_aveCoverage) and coverage<=(tmp_aveCoverage+0.5*tmp_aveCoverage) and np.mean(similarityList)>=tmp_avgThreshold:
                    avgCov_coverage[0].append(coverage)
                    avgCov_SNPs[0].append(coverageSNPs[coverage])
                else:
                    avgCov_coverage.append([coverage])
                    avgCov_SNPs.append([coverageSNPs[coverage]])
                continue

            #find close coverage in the list if there are more than one haplotype in coverage list
            closeCoverage = 10000
            closeID = ''
            equalIDList = []
            differenceList = [abs(coverage-np.mean(avgCov_coverage[i])) for i in range(len(avgCov_coverage))]

            #find the similarity value and ID
            minCoverage = np.min(differenceList)
            indexList = [index for index,value in enumerate(differenceList) if value==minCoverage]

            #check whether need to build a new cluster
            averageDistance = 0.0
            sorted_avgCov = sorted([np.mean(value) for index, value in enumerate(avgCov_coverage)])
            distanceList = [sorted_avgCov[i]-sorted_avgCov[i-1] for i in range(1,len(sorted_avgCov))]

            if len(distanceList)==0:
                averageDistance = minCoverage
            else:
                averageDistance = np.mean(distanceList)

            #add a new cluster
            if minCoverage>0.5*averageDistance:
                print 'here'
                avgCov_coverage.append([coverage])
                avgCov_SNPs.append([coverageSNPs[coverage]])
            #don't add new cluster, merge new into known cluster
            else:
                if len(indexList)==1:
                    avgCov_coverage[indexList[0]].append(coverage)
                    avgCov_SNPs[indexList[0]].append(coverageSNPs[coverage])
                else:
                    #need to calculate which cluster need to be merged
                    minimumReliability = 100000
                    minimumID = ''
                    for index in indexList:
                        snp1 = set()
                        for item in avgCov_SNPs[index]:
                            for one in item:
                                snp1.add(one)
                        snp2 = set(coverageSNPs[coverage])
                        reliability = calculate_reliability(snp1,snp2)
                        if reliability<minimumReliability:
                            minimumReliability = reliability
                            minimumID = index

                    avgCov_coverage[minimumID].append(coverage)
                    avgCov_SNPs[minimumID].append(coverageSNPs[coverage])



result = {}
#vote for SNPs agreed by majority of haplotype
for i in range(len(avgCov_coverage)):
    coverages = avgCov_coverage[i]
    SNPsCluster = avgCov_SNPs[i]

    #calculate how many of occurrence for each SNPs
    majorityThreshold = len(SNPsCluster) / 2.0
    SNPs = []
    SNPs_dist = {}
    for oneCluster in SNPsCluster:
        for one in set(oneCluster):
            if one in SNPs_dist:
                SNPs_dist[one]+=1
            else:
                SNPs_dist.update({one:1})

    #only save SNPs agree by most
    for key,value in SNPs_dist.iteritems():
        if value>majorityThreshold:
            SNPs.append(key)

    averageCoverage = np.mean(coverages)
    result.update({averageCoverage:SNPs})


with open('%s' %finalPredictionsFile,'w') as f:
    for coverage in sorted(result.keys()):
        snps = result[coverage]
        f.write('>'+str(coverage))
        f.write('\n')
        tmp = '\n'.join(snps)
        f.write(tmp)
        f.write('\n')



