#!/usr/bin/python
import math
import numpy
import copy
from Statistics import Poisson
import Constants

def EstimateParameters(coverages):
    
    
    #Initialization
    coverages = sorted(coverages)
    # lastDecileIndex = int(math.ceil(0.9 * len(coverages)))
    # meanLastDecile = numpy.mean(coverages[lastDecileIndex:len(coverages)])
    # totalCoverage = meanLastDecile
    # meanCoverage = numpy.mean(coverages)

    #?XIN, fix bug.
    if len(coverages)<10:
        m = len(coverages)
    else:
        m = 10
    
    alphaInit = float(1) / m 
    alpha = [alphaInit] * m
    
    intervalLen = len(coverages) / m
    print intervalLen

    #divide coverage into m groups, and calculate the average coverage for each group
    landa = []
    print len(coverages)
    for i in range(1, m):
        landa.append(numpy.mean(coverages[(i - 1) * intervalLen : i * intervalLen]))
    landa.append(numpy.mean(coverages[(m - 1) * intervalLen : ]))
    
      
    finished = False
      
    Z = numpy.zeros((len(coverages), m))
      
    while finished == False:
        #Expectation step
        for i in range(len(coverages)):
            Z[i] = [0] * m
            xi = coverages[i]
            for j in range(m):                
                Z[i][j] = alpha[j] * Poisson(landa[j], xi)
                #print Z[i][j]
                temp = [alpha[k] * Poisson(landa[k], xi) for k in range(m)]               
                if (sum(temp) == 0):
                    p = [(landa[k], xi) for k in range(m)]
                    print "Oooops! sum(temp) == 0"
                    print p
                Z[i][j] /= sum(temp)
          
        prevAlpha = copy.copy(alpha)
        prevLanda = copy.copy(landa)

        #Maximization step
        revCount = float(1) / len(coverages)        
        for j in range(m):
            temp = [Z[i][j] for i in range(len(coverages))]
            alpha[j] = revCount * sum(temp)
              
            temp2 = [Z[i][j] * coverages[i] for i in range(len(coverages))]
            landa[j] = sum(temp2) / sum(temp)
              
         
    #     print sum(alpha)
              
        subAlpha = [abs(a - b) for a, b in zip(alpha, prevAlpha)]
        subLanda = [abs(a - b) for a, b in zip(landa, prevLanda)]
      
        r1 = [round(a, 2) for a in alpha]
        r2 = [round(l, 2) for l in landa]
        r = "\n".join([str(r2[i]) + "," + str(r1[i]) for i in range(m)])    
        # print r
        # print "******************"

        #stop criteria
        if all(a < Constants.ALPHA_EM_STOP_THRESHOLD for a in subAlpha) and all(l < Constants.LANDA_EM_STOP_THRESHOLD for l in subLanda):
            finished = True
             
    r1 = [round(a, 2) for a in alpha]
    r2 = [round(l, 2) for l in landa]
    r = "\n".join([str(r2[i]) + "," + str(r1[i]) for i in range(m)])    
    print r   
    #
    alphaThreshold = alphaInit * 0.001
    print "alphaThreshold", alphaThreshold
    #fixed bug here
    #for i in range(m - 1, 0, -1):
    for i in range(m - 1, -1, -1):
        if alpha[i] < alphaThreshold:
            landa.pop(i)
            alpha.pop(i)
     
    landaThreshold = Constants.LANDA_EM_MERGING_THRESHOLD
    print "landaThreshold", landaThreshold
    # fixed bug here
    for i in range(len(landa) - 1, 0, -1):
    #for i in range(len(landa) - 1, -1, -1):
        if abs(landa[i] - landa[i - 1]) <= landaThreshold:
            landa[i - 1] = (landa[i] + landa[i - 1]) / 2.0
            alpha[i - 1] = alpha[i] + alpha[i - 1]
            alpha.pop(i)
            landa.pop(i)
     
    r1 = [round(l, 5) for l in landa]
    r2 = [round(a, 5) for a in alpha]
    print '#########################'
    r = "\n".join([str(r1[i]) + "\t" + str(r2[i]) for i in range(len(alpha))])
    print r 
    print '#########################'
    return landa,alpha
    

