#!/usr/bin/python
import math
from math import sqrt
import numpy as np


def Poisson(landa, x):
    if landa < 1:
        p = (landa ** x) / math.factorial(x)
        p *= (math.e ** (-landa))
        return p
    else: #When landa is large, we can approximate Poisson with Normal distribution
        n = Normal(landa, sqrt(landa), x)
        return n
        
    
def Normal(mean, variance, x):
    n = 1.0 / (variance * sqrt(2 * math.pi))
    ep = ((x - mean)**2) / (2.0 * (variance**2))
    ep *= -1
    n *= math.e ** ep
    return n


def percentile(N, percent, key=lambda x:x):
    if not N:
        return None
    k = (len(N)-1) * percent
    f = math.floor(k)
    c = math.ceil(k)
    if f == c:
        return key(N[int(k)])
    d0 = key(N[int(f)]) * (c-k)
    d1 = key(N[int(c)]) * (k-f)
    return d0+d1


def reject_outliers(data, m=2):
    print "rejecting outliers"
    mn = np.mean(data)
    st =  np.std(data)
    return [abs(d - mn) < m * st for d in data]
